{ਬ ᠭ }

UNIT UserIntr;

INTERFACE

USES CRT, DOS, WIN, WINHARRY, TEXTMENU, TextCons, VERYLIBC, WinEdit,
     USESMETA;

VAR
   Menu   : Array [1..4] OF PMenu;
   WinRes : Array [1..4] OF Integer;

PROCEDURE InitHMenu      (I : Byte);
PROCEDURE DoneMenu       (I : Byte);
PROCEDURE InitVMenu1     (I : Byte);
PROCEDURE ExtraCloseMenu (I : Byte);
PROCEDURE InitVMenu2     (I : Byte);
PROCEDURE InitVMenu2_1   (I : Byte);
PROCEDURE InitVMenu2_2   (I : Byte);
PROCEDURE InitVMenu2_3   (I : Byte);
PROCEDURE InitVMenu2_4   (I : Byte);
PROCEDURE EditErgebnisse;
PROCEDURE InitCaseTest (I : Byte);
PROCEDURE DoneCaseTest (I : Byte; K : Integer);
PROCEDURE InsertNewRecordIfCMP ( I : Byte );
PROCEDURE DeleteCurRecordIfCMP ( I : Byte );
FUNCTION LineEdit (X1, Y1 : Byte; Long : Byte; StartString : String; Attr : Byte) : String;
PROCEDURE EditRecComments (I : Byte);
PROCEDURE InitCaseNaht (I : Byte);
PROCEDURE RestoreCaseNaht (I, J : Byte);
PROCEDURE EditWerkStoff (I : Byte);
PROCEDURE DoneAufgabe;
PROCEDURE InitCaseTypeLaser (I : Byte);
PROCEDURE RestoreCaseTypeLaser (I, J : Integer);
PROCEDURE DoneLaser;
PROCEDURE DoneOptik;
PROCEDURE DoneTechnolog;
PROCEDURE InitTypeShield (I : Byte);
PROCEDURE RestoreTypeShield (I, J : Integer);
FUNCTION NotEnterNewNameDatenBasis : Boolean;
FUNCTION InitSearchDatenBasis (I : Byte) : Boolean;
PROCEDURE DoneSearchBasis (I : Byte);
PROCEDURE InitNewNameBasis (I : Byte; F : Byte);
PROCEDURE DoneNewNameDatenBasis;

IMPLEMENTATION

PROCEDURE InitHMenu (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 1;
          Y1           := 1;
          X2           := 80;
          WT           := WW [I];
          Realize      := 4;
          Aktive       := False;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeNoPresent;
          FNameSCR     := ' User Interface for DB-LASIM // (c) Copyright 1997 by Igor Dikshev ';
          WITH Lines [1] DO BEGIN
               Name  := HMPunkten1;
               Num   := 1;
          END;
          WITH Lines [2] DO BEGIN
               Name  := HMPunkten2;
               Num   := 1;
          END;
          WITH Lines [3] DO BEGIN
               Name  := HMPunkten3;
               Num   := 1;
          END;
          WITH Lines [4] DO BEGIN
               Name  := HMPunkten4;
               Num   := 1;
          END;
     END;
END;

PROCEDURE DoneMenu (I : Byte);
BEGIN
     Dispose (Menu [I]);
END;

PROCEDURE InitVMenu1 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 1;
          Y1           := 2;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := 5;
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu2.scr';
          WITH Lines [1] DO BEGIN
               Name  := VM1Punkten1;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [2] DO BEGIN
               Name  := VM1Punkten2;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [3] DO BEGIN
               Name  := VM1Punkten3;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [4] DO BEGIN
               Name  := VM1Punkten4;
               Num   := 6;
               Info  := 0;
          END;
          WITH Lines [5] DO BEGIN
               Name  := VM1Punkten5;
               Num   := 2;
               Info  := 0;
          END;
     END;
END;

PROCEDURE ExtraCloseMenu (I : Byte);
BEGIN
     ActivateWIN (Menu [I]^. WT);
     CloseWinMenu (Menu [I]^);
END;

PROCEDURE InitVMenu2 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. Lines [3]. x;
          Y1           := 2;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := 4;
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu2.scr';
          WITH Lines [1] DO BEGIN
               Name  := AufgabePunkten;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [2] DO BEGIN
               Name  := LaserPunkten;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [3] DO BEGIN
               Name  := OptikPunkten;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [4] DO BEGIN
               Name  := TechnolPunkten;
               Num   := 1;
               Info  := 0;
          END;
     END;
END;

PROCEDURE InitVMenu2_1 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1 + 3;
          Y1           := Menu [I-1]^. Y1 + Menu [I-1]^. Lines [1]. y + 1;
          TS80         := '';
          FrameSort    := 2;
          WT           := WW [I];
          Realize      := 7;
          Aktive       := False;
          DexParMax    := 21;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu3.scr';
          WITH Lines [1] DO BEGIN
               Name  := A_Punkten1;
               Num   := 1;
               Info  := 1;
               Param := TypeI_Naht;
               IF CurrentDatHandler^. RecordersFields. VerbindungTyp = 'U'
               THEN Param := TypeU_Naht;
          END;
          WITH Lines [2] DO BEGIN
               Name  := A_Punkten2;
               Num   := 1;
               Info  := 1;
               Param := CurrentDatHandler^. RecordersFields. WerkstoffName;
          END;
          WITH Lines [3] DO BEGIN
               Name  := A_Punkten3;
               Num   := 1;
               Info  := 1;
               Param := 'Lieferung';
          END;
          WITH Lines [4] DO BEGIN
               Name  := A_Punkten4;
               Num   := 1;
               Info  := 1;
               Param := 'Waagerecht';
          END;
          WITH Lines [5] DO BEGIN
               Name  := A_Punkten5;
               Num   := 13;
               Info  := 2;
               MinValue   := 0.5;
               MaxValue   := 6.0;
               StepPar    := 0.1;
               DoPoint    := 1;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. BlechDicke1 < MinValue
               THEN CurrentDatHandler^. RecordersFields. BlechDicke1 := MinValue;
               IF CurrentDatHandler^. RecordersFields. BlechDicke1 > MaxValue
               THEN CurrentDatHandler^. RecordersFields. BlechDicke1 := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. BlechDicke1:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [6] DO BEGIN
               Name  := A_Punkten6;
               Num   := 13;
               Info  := 2;
               MinValue   := 0.5;
               MaxValue   := 3.0;
               StepPar    := 0.1;
               DoPoint    := 1;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. BlechDicke2 < MinValue
               THEN CurrentDatHandler^. RecordersFields. BlechDicke2 := MinValue;
               IF CurrentDatHandler^. RecordersFields. BlechDicke2 > MaxValue
               THEN CurrentDatHandler^. RecordersFields. BlechDicke2 := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. BlechDicke2:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [7] DO BEGIN
               Name  := A_Punkten7;
               Num   := 1;
               Info  := 2;
               MinValue   := 0.00;
               MaxValue   := 0.20;
               StepPar    := 0.01;
               DoPoint    := 1;
               AfterPoint := 2;
               IF CurrentDatHandler^. RecordersFields. SpaltValue < MinValue
               THEN CurrentDatHandler^. RecordersFields. SpaltValue := MinValue;
               IF CurrentDatHandler^. RecordersFields. SpaltValue > MaxValue
               THEN CurrentDatHandler^. RecordersFields. SpaltValue := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. SpaltValue:DoPoint:AfterPoint, Param);
          END;
     END;
END;

PROCEDURE InitVMenu2_2 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1 + 3;
          Y1           := Menu [I-1]^. Y1 + Menu [I-1]^. Lines [2]. y + 1;
          TS80         := '';
          FrameSort    := 2;
          WT           := WW [I];
          Realize      := 4;
          Aktive       := False;
          DexParMax    := 10;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu3.scr';
          WITH Lines [1] DO BEGIN
               Name  := L_Punkten1;
               Num   := 7;
               Info  := 1;
               Param := Type_Laser_CO2;
               IF CurrentDatHandler^. RecordersFields. TypeLaser = 0
               THEN Param := Type_Laser_YAG;
          END;
          WITH Lines [2] DO BEGIN
               Name  := L_Punkten2;
               Num   := 1;
               Info  := 2;
               MinValue   := 500;
               MaxValue   := 10000;
               StepPar    := 10;
               DoPoint    := 5;
               AfterPoint := 0;
               IF CurrentDatHandler^. RecordersFields. LaserLeistung < Round(MinValue)
               THEN CurrentDatHandler^. RecordersFields. LaserLeistung := Round(MinValue);
               IF CurrentDatHandler^. RecordersFields. LaserLeistung > Round(MaxValue)
               THEN CurrentDatHandler^. RecordersFields. LaserLeistung := Round(MaxValue);
               STR (CurrentDatHandler^. RecordersFields. LaserLeistung:DoPoint, Param);
          END;
          WITH Lines [3] DO BEGIN
               Name  := L_Punkten4;
               Num   := 1;
               Info  := 2;
               MinValue   := 10.0;
               MaxValue   := 80.0;
               StepPar    := 0.1;
               DoPoint    := 2;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. RohrDurchMess < MinValue
               THEN CurrentDatHandler^. RecordersFields. RohrDurchMess := MinValue;
               IF CurrentDatHandler^. RecordersFields. RohrDurchMess > MaxValue
               THEN CurrentDatHandler^. RecordersFields. RohrDurchMess := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. RohrDurchMess:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [4] DO BEGIN
               Name  := L_Punkten5;
               Num   := 1;
               Info  := 2;
               MinValue   := 1.0;
               MaxValue   := 2.0;
               StepPar    := 0.1;
               DoPoint    := 1;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. Intensitaet < MinValue
               THEN CurrentDatHandler^. RecordersFields. Intensitaet := MinValue;
               IF CurrentDatHandler^. RecordersFields. Intensitaet > MaxValue
               THEN CurrentDatHandler^. RecordersFields. Intensitaet := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. Intensitaet:DoPoint:AfterPoint, Param);
          END;
     END;
END;

PROCEDURE InitVMenu2_3 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1 + 3;
          Y1           := Menu [I-1]^. Y1 + Menu [I-1]^. Lines [3]. y + 1;
          TS80         := '';
          FrameSort    := 2;
          WT           := WW [I];
          Realize      := 4;
          Aktive       := False;
          DexParMax    := 10;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu3.scr';
          WITH Lines [1] DO BEGIN
               Name  := O_Punkten1;
               Num   := 1;
               Info  := 2;
               MinValue   := 100;
               MaxValue   := 500;
               StepPar    := 1;
               DoPoint    := 3;
               AfterPoint := 0;
               IF CurrentDatHandler^. RecordersFields. Brennweite < Round(MinValue)
               THEN CurrentDatHandler^. RecordersFields. Brennweite := Round(MinValue);
               IF CurrentDatHandler^. RecordersFields. Brennweite > Round(MaxValue)
               THEN CurrentDatHandler^. RecordersFields. Brennweite := Round(MaxValue);
               STR (CurrentDatHandler^. RecordersFields. Brennweite:DoPoint, Param);
          END;
          WITH Lines [2] DO BEGIN
               Name  := O_Punkten2;
               Num   := 1;
               Info  := 2;
               MinValue   := 0.10;
               MaxValue   := 0.80;
               StepPar    := 0.01;
               DoPoint    := 1;
               AfterPoint := 2;
               IF CurrentDatHandler^. RecordersFields. DurchMesser < MinValue
               THEN CurrentDatHandler^. RecordersFields. DurchMesser := MinValue;
               IF CurrentDatHandler^. RecordersFields. DurchMesser > MaxValue
               THEN CurrentDatHandler^. RecordersFields. DurchMesser := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. DurchMesser:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [3] DO BEGIN
               Name  := O_Punkten3;
               Num   := 17;
               Info  := 0;
               STR (CurrentDatHandler^. RecordersFields. AngleBeta:2:1, Param);
          END;
          WITH Lines [4] DO BEGIN
               Name  := O_Punkten4;
               Num   := 17;
               Info  := 2;
               MinValue   := -20;
               MaxValue   := 20;
               StepPar    := 1;
               DoPoint    := 3;
               AfterPoint := 0;
               IF CurrentDatHandler^. RecordersFields. AngleAlfa < MinValue
               THEN CurrentDatHandler^. RecordersFields. AngleAlfa := MinValue;
               IF CurrentDatHandler^. RecordersFields. AngleAlfa > MaxValue
               THEN CurrentDatHandler^. RecordersFields. AngleAlfa := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. AngleAlfa:DoPoint:AfterPoint, Param);
          END;
     END;
END;

PROCEDURE InitVMenu2_4 (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1 + 3;
          Y1           := Menu [I-1]^. Y1 + Menu [I-1]^. Lines [4]. y + 1;
          TS80         := '';
          FrameSort    := 2;
          WT           := WW [I];
          Realize      := 4;
          Aktive       := False;
          DexParMax    := 10;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu3.scr';
          WITH Lines [1] DO BEGIN
               Name  := T_Punkten1;
               Num   := 1;
               Info  := 2;
               MinValue   := 0.5;
               MaxValue   := 15.0;
               StepPar    := 0.1;
               DoPoint    := 2;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. SchGeschwind < MinValue
               THEN CurrentDatHandler^. RecordersFields. SchGeschwind := MinValue;
               IF CurrentDatHandler^. RecordersFields. SchGeschwind > MaxValue
               THEN CurrentDatHandler^. RecordersFields. SchGeschwind := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. SchGeschwind:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [2] DO BEGIN
               Name  := T_Punkten2;
               Num   := 1;
               Info  := 2;
               MinValue   := -5.0;
               MaxValue   := 5.0;
               StepPar    := 0.1;
               DoPoint    := 2;
               AfterPoint := 1;
               IF CurrentDatHandler^. RecordersFields. FokusLage < MinValue
               THEN CurrentDatHandler^. RecordersFields. FokusLage := MinValue;
               IF CurrentDatHandler^. RecordersFields. FokusLage > MaxValue
               THEN CurrentDatHandler^. RecordersFields. FokusLage := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. FokusLage:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [3] DO BEGIN
               Name  := T_Punkten3;
               Num   := 1;
               Info  := 2;
               MinValue   := 20;
               MaxValue   := 700;
               StepPar    := 1;
               DoPoint    := 3;
               AfterPoint := 0;
               IF CurrentDatHandler^. RecordersFields. AnfangTemper < MinValue
               THEN CurrentDatHandler^. RecordersFields. AnfangTemper := MinValue;
               IF CurrentDatHandler^. RecordersFields. AnfangTemper > MaxValue
               THEN CurrentDatHandler^. RecordersFields. AnfangTemper := MaxValue;
               STR (CurrentDatHandler^. RecordersFields. AnfangTemper:DoPoint:AfterPoint, Param);
          END;
          WITH Lines [4] DO BEGIN
               Name  := T_Punkten4;
               Num   := 1;
               Info  := 1;
               WITH CurrentDatHandler^. RecordersFields DO BEGIN
                    IF GasArgon = 100 THEN PARAM := ARGON_SCHUTZGAS ELSE
                    IF GasHelium = 100 THEN PARAM := HELIJ_SCHUTZGAS ELSE
                    PARAM := SMES_SCHUTZGAS;
               END;
          END;
     END;
END;

PROCEDURE EditErgebnisse;
VAR
   StateWin : WinState;
CONST
     Xp = 10;
     Yp = 2;

procedure InitPString;
begin
     Realize := CurrentDatHandler^. HeaderRecordDat. QualitaetCount;
     i := 1;
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. Einbrandtiefe:2:2,Okn.W[i].PS^[j]);
     Inc (i);
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. BreiteOben:2:2,Okn.W[i].PS^[j]);
     Inc (i);
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. BreiteInMitte:2:2,Okn.W[i].PS^[j]);
     Inc (i);
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. BreiteUnten:2:2,Okn.W[i].PS^[j]);
     Inc (i);
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. UberhohungOben:2:2,Okn.W[i].PS^[j]);
     Inc (i);
     for j:=1 to Realize do
         Str (CurrentDatHandler^. QualitaetWerks [j]. UberhohungUnten:2:2,Okn.W[i].PS^[j]);
end;

procedure DonePString;
Var
   EC : Integer;
begin
     CurrentDatHandler^. HeaderRecordDat. QualitaetCount := Realize ;
     i := 1;
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j], CurrentDatHandler^. QualitaetWerks [j]. Einbrandtiefe, EC);

     Inc (i);
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j],CurrentDatHandler^. QualitaetWerks [j]. BreiteOben,EC);
     Inc (i);
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j],CurrentDatHandler^. QualitaetWerks [j]. BreiteInMitte,EC);
     Inc (i);
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j],CurrentDatHandler^. QualitaetWerks [j]. BreiteUnten,EC);
     Inc (i);
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j],CurrentDatHandler^. QualitaetWerks [j]. UberhohungOben,EC);
     Inc (i);
     for j:=1 to Realize do
         Val (Okn.W[i].PS^[j],CurrentDatHandler^. QualitaetWerks [j]. UberhohungUnten,EC);
end;

BEGIN
   Title:=TitleEdit;
   Okn.Lin:= 10;
   Okn.WReal:= 6;
   Okn.x:=15;
   Okn.y:=8;
   Okn.W[1].Col:=8;
   Okn.W[2].Col:=8;
   Okn.W[3].Col:=8;
   Okn.W[4].Col:=8;
   Okn.W[5].Col:=8;
   Okn.W[6].Col:=8;
   Write_To_Podwal (' Hot keys:   '#29'  '#24'  '#25'  '#26'  '#27'  '#17#196'  '#17#217+
                    +'  Ctrl+Y  Ins  Del  Home  End  PgUp  PgDwn', WindowHKey);

   Init;
   InitPString;
   SaveWin(StateWin);
   Window(1,1,80,25);
   TextAttr := WindowColor;
   GotoXY (Okn.x-Xp, Okn.y-Yp);
   WriteLn ('Ŀ');
   GotoXY (Okn.x-Xp, Okn.y+1-Yp);
   WriteLn ('Erfahrung  e, mm    b1, mm  b1/2, mm  b2, mm   h1, mm   h2, mm ');
   GotoXY (Okn.x-Xp, Okn.y+2-Yp);
   WriteLn ('Ĵ');
   GotoXY (Okn.x-Xp, Okn.y+3-Yp);
   WriteLn ('    1    ');
   GotoXY (Okn.x-Xp, Okn.y+4-Yp);
   WriteLn ('    2    ');
   GotoXY (Okn.x-Xp, Okn.y+5-Yp);
   WriteLn ('    3    ');
   GotoXY (Okn.x-Xp, Okn.y+6-Yp);
   WriteLn ('    4    ');
   GotoXY (Okn.x-Xp, Okn.y+7-Yp);
   WriteLn ('    5    ');
   GotoXY (Okn.x-Xp, Okn.y+8-Yp);
   WriteLn ('    6    ');
   GotoXY (Okn.x-Xp, Okn.y+9-Yp);
   WriteLn ('    7    ');
   GotoXY (Okn.x-Xp, Okn.y+10-Yp);
   WriteLn ('    8    ');
   GotoXY (Okn.x-Xp, Okn.y+11-Yp);
   WriteLn ('    9    ');
   GotoXY (Okn.x-Xp, Okn.y+12-Yp);
   WriteLn ('   10    ');
   GotoXY (Okn.x-Xp, Okn.y+13-Yp);
   WriteLn ('');
   RestoreWin(StateWin);
   Editor;
   DonePString;
{   REPEAT
         Editor;
         ByteResult := YesNoCancel (STEALCH, SAVESTEAL);
         CASE ByteResult OF
              1 : BEGIN
                  DonePString;
                  Break;
                  END;
              2 : Break;
         END;
   UNTIL False;}
   Done;
END;

PROCEDURE InitCaseTest (I : Byte);
VAR
   J : Byte;
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 1; {Menu [I-1]^. Lines [2]. x;}
          Y1           := 2;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := HeaderDaten^. AllesRecord;
          Aktive       := False;
          DexParMax    := 67;
          KeysForPress := KeyNoPresent;
          ShadePresent := ShadeNoPresent;
          FNameSCR     := 'Menu2.scr';
          CurrentDatHandler := HeaderBufferDaten^. Next;
          J := 1;
          REPEAT
          WITH Lines [J] DO BEGIN
               Str (J, Name);
               Name := Test_Msg + Name;
               Num   := 1;
               Info  := 1;
               Param := CurrentDatHandler^. HeaderRecordDat. RecordComment;
          END;
          Inc (J);
          IF J > HeaderDaten^. AllesRecord THEN Break;
          CurrentDatHandler := CurrentDatHandler^. Next;
          UNTIL CurrentDatHandler = HeaderBufferDaten;
          CurrentDatHandler := HeaderBufferDaten^. Next;
     END;
END;

PROCEDURE DoneCaseTest (I : Byte; K : Integer);
VAR
   J : Byte;
BEGIN
    IF K > 0 THEN BEGIN
       CurrentDatHandler := HeaderBufferDaten^. Next;
       FOR J := 1 TO K-1 DO
           CurrentDatHandler := CurrentDatHandler^. Next;
    END;
  DoneMenu (I);
END;

PROCEDURE EditRecComments (I : Byte);
VAR
   J : Byte;
BEGIN
    CurrentDatHandler := HeaderBufferDaten^. Next;
       FOR J := 1 TO I-1 DO
           CurrentDatHandler := CurrentDatHandler^. Next;
    CurrentDatHandler^. HeaderRecordDat. RecordComment :=
    LineEdit (Menu [2]^. X2 - Menu [2]^. DexParMax,
              Menu [2]^. Y1 + Menu [2]^. Lines [I]. y,
              65, CurrentDatHandler^. HeaderRecordDat. RecordComment, WindowHHKey);
    Menu [2]^. Lines [I]. Param := CurrentDatHandler^. HeaderRecordDat. RecordComment;
    HMESSGEONELINE := Test_Msg + ': ' + CurrentDatHandler^. HeaderRecordDat. RecordComment;
END;

PROCEDURE InsertNewRecordIfCMP ( I : Byte );
VAR
   J : Byte;
BEGIN
     CurrentDatHandler := HeaderBufferDaten^. Next;
     FOR J := 1 TO I-1 DO
         CurrentDatHandler := CurrentDatHandler^. Next;
     IF CurrentDatHandler^.Prevision  = HeaderBufferDaten THEN
        InsertNewFirstRecord
     ELSE
        InsertNewRecordAfter;
     HMESSGEONELINE := Test_Msg + ': ' + CurrentDatHandler^. HeaderRecordDat. RecordComment;
END;

PROCEDURE DeleteCurRecordIfCMP ( I : Byte );
VAR
   J : Byte;
BEGIN
     CurrentDatHandler := HeaderBufferDaten^. Next;
     FOR J := 1 TO I-1 DO
         CurrentDatHandler := CurrentDatHandler^. Next;
     IF (CurrentDatHandler^.Prevision  = HeaderBufferDaten) AND
        (HeaderDaten^. AllesRecord > 1) THEN
        DeleteFirstRecord
     ELSE
        DeleteNoFirstRecord;
     HMESSGEONELINE := Test_Msg + ': ' + CurrentDatHandler^. HeaderRecordDat. RecordComment;
END;

FUNCTION LineEdit (X1, Y1 : Byte; Long : Byte; StartString : String; Attr : Byte) : String;
VAR
   S : String;
   Ch : Char;
   kx : Byte;
   flag : Boolean;
   StateWin : WinState;
BEGIN
     SaveWin(StateWin);
     Window (X1, Y1, X1 + Long, Y1);
     TextAttr := Attr;
     S := StartString;
     kx := 1;
     flag := false;
     REPEAT
          GotoXY (1, 1);
          ClrEOL;
          Write (S);
          GotoXY (kx, 1);
          if flag then SetB ELSE SetN;
          REPEAT UNTIL KeyPressed;
          SetO;
          Ch := ReadKey;
          CASE ORD (Ch) OF
               13 : BEGIN
                    LineEdit := S;
                    Break;
                    END;
               27 : BEGIN
                    LineEdit := StartString;
                    Break;
                    END;
               8  : IF kx > 1 THEN BEGIN
                       Delete (S, kx-1, 1);
                       dec (kx);
                    END;
               0  : BEGIN
                    Ch := ReadKey;
                    CASE Ord (Ch) OF
                         71 : kx := 1;
                         79 : kx := Length (S)+1;
                         82 : flag := not flag;
                         83 : Delete (S, kx, 1);
                         75 : if kx > 1 then dec (kx);
                         77 : if kx < Length (s) + 1 then inc (kx);
                    END;
                    END;
          ELSE
              IF flag then s [kx] := ch else
                 Insert (Ch, S, kx);
              Inc (kx);
          END;
          If Length (S) > Long THEN Byte (S[0]) := Long;
          If kx > Long then kx := Long;
     UNTIL False;
     RestoreWin(StateWin);
END;

PROCEDURE InitCaseNaht (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1;
          Y1           := Menu [I-1]^. Y2+1;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := 2;
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu4.scr';
          WITH Lines [1] DO BEGIN
               Name  := TypeI_Naht;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [2] DO BEGIN
               Name  := TypeU_Naht;
               Num   := 1;
               Info  := 0;
          END;
     END;
END;

PROCEDURE RestoreCaseNaht (I, J : Byte);
BEGIN
     CASE J OF
          1 : BEGIN
              Menu [3]^. Lines [I]. Param := TypeI_Naht;
              CurrentDatHandler^. RecordersFields. VerbindungTyp := 'I'
              END;
          2 : BEGIN
              Menu [3]^. Lines [I]. Param := TypeU_Naht;
              CurrentDatHandler^. RecordersFields. VerbindungTyp := 'U'
              END;
     END;
END;

PROCEDURE InitMenuWerkstoff (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 58;
          Y1           := 2;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyNoPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu4.scr';
     END;
END;

PROCEDURE DoneWerkstoff (I : Byte);
BEGIN
     Menu [3]^. Lines [2]. Param := Menu [4]^. Lines [I]. Name;
     CurrentDatHandler^. RecordersFields. WerkstoffName := Menu [4]^. Lines [I]. Name;
     CurrentDatHandler^. RecordersFields. NameMetaBase1 := Menu [4]^. Lines [I]. Param + MET;
     CurrentDatHandler^. RecordersFields. NameXimBase1 := Menu [4]^. Lines [I]. Param + XIM;
     CurrentDatHandler^. RecordersFields. NameComBase1 := Menu [4]^. Lines [I]. Param + CMT;
     CurrentDatHandler^. RecordersFields. NameMetaBase2 := Menu [4]^. Lines [I]. Param + MET;
     CurrentDatHandler^. RecordersFields. NameXimBase2 := Menu [4]^. Lines [I]. Param + XIM;
     CurrentDatHandler^. RecordersFields. NameComBase2 := Menu [4]^. Lines [I]. Param + CMT;
     IF Menu [4]^ .Lines [I]. Num = 1 THEN
        CurrentDatHandler^. RecordersFields. MaterialByte := 'A'
     ELSE
        CurrentDatHandler^. RecordersFields. MaterialByte := 'F';
END;

PROCEDURE EditWerkStoff (I : Byte);
BEGIN
    Data_Path := PATH_FILE;
    New (Menu [4]);
    InitMenuWerkstoff (4);
    IF VIEW_META_BASES (Menu [4]^) THEN BEGIN
       IF Menu [4]^. Realize > 20 THEN Menu [4]^. ShadePresent := ShadeNoPresent;
       IF Menu [4]^. Realize > 21 THEN Menu [4]^. Realize := 21;
       WinRes [4] := VMenu (Menu [4]^, InMenuStart, OutMenuAlways, OutMenuIfErase);
       IF WinRes [4] > 0 THEN DoneWerkstoff (WinRes [4]);
       DoneMenu (4);
    END ELSE BEGIN
        DoneMenu (4);
        CurrentDatHandler^. RecordersFields. WerkstoffName :=
        LineEdit (Menu [3]^. X2 - Menu [3]^. DexParMax,
                  Menu [3]^. Y1 + Menu [3]^. Lines [I]. y,
                  20, CurrentDatHandler^. RecordersFields. WerkstoffName, WindowHHKey);
        Menu [3]^. Lines [I]. Param := CurrentDatHandler^. RecordersFields. WerkstoffName;
    END;
END;

PROCEDURE DoneAufgabe;
VAR
   EC : Integer;
BEGIN
     Val (Menu [3]^. Lines [5]. Param, CurrentDatHandler^. RecordersFields. BlechDicke1, EC);
     Val (Menu [3]^. Lines [6]. Param, CurrentDatHandler^. RecordersFields. BlechDicke2, EC);
     Val (Menu [3]^. Lines [7]. Param, CurrentDatHandler^. RecordersFields. SpaltValue, EC);
END;

PROCEDURE InitCaseTypeLaser (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1;
          Y1           := Menu [I-1]^. Y2+1;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := 2;
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu4.scr';
          WITH Lines [1] DO BEGIN
               Name  := Type_Laser_CO2;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [2] DO BEGIN
               Name  := Type_Laser_YAG;
               Num   := 1;
               Info  := 0;
          END;
     END;
END;

PROCEDURE RestoreCaseTypeLaser (I, J : Integer);
BEGIN
     CASE J OF
          1 : BEGIN
              Menu [3]^. Lines [I]. Param := Type_Laser_CO2;
              CurrentDatHandler^. RecordersFields. TypeLaser := 1;
              END;
          2 : BEGIN
              Menu [3]^. Lines [I]. Param := Type_Laser_YAG;
              CurrentDatHandler^. RecordersFields. TypeLaser := 0;
              END;
     END;
END;

PROCEDURE DoneLaser;
VAR
   EC : Integer;
BEGIN
     Val (Menu [3]^. Lines [2]. Param, CurrentDatHandler^. RecordersFields. LaserLeistung, EC);
     Val (Menu [3]^. Lines [3]. Param, CurrentDatHandler^. RecordersFields. RohrDurchMess, EC);
     Val (Menu [3]^. Lines [4]. Param, CurrentDatHandler^. RecordersFields. Intensitaet, EC);
END;

PROCEDURE DoneOptik;
VAR
   EC : Integer;
BEGIN
     Val (Menu [3]^. Lines [1]. Param, CurrentDatHandler^. RecordersFields. Brennweite, EC);
     Val (Menu [3]^. Lines [2]. Param, CurrentDatHandler^. RecordersFields. DurchMesser, EC);
     Val (Menu [3]^. Lines [4]. Param, CurrentDatHandler^. RecordersFields. AngleAlfa, EC);
END;

PROCEDURE DoneTechnolog;
VAR
   EC : Integer;
BEGIN
     Val (Menu [3]^. Lines [1]. Param, CurrentDatHandler^. RecordersFields. SchGeschwind, EC);
     Val (Menu [3]^. Lines [2]. Param, CurrentDatHandler^. RecordersFields. FokusLage, EC);
     Val (Menu [3]^. Lines [3]. Param, CurrentDatHandler^. RecordersFields. AnfangTemper, EC);
END;

PROCEDURE InitTypeShield (I : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := Menu [I-1]^. X1;
          Y1           := Menu [I-1]^. Y2+1;
          TS80         := '';
          FrameSort    := 1;
          WT           := WW [I];
          Realize      := 3;
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu4.scr';
          WITH Lines [1] DO BEGIN
               Name  := ARGON_SCHUTZGAS;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [2] DO BEGIN
               Name  := HELIJ_SCHUTZGAS;
               Num   := 1;
               Info  := 0;
          END;
          WITH Lines [3] DO BEGIN
               Name  := SMES_SCHUTZGAS;
               Num   := 1;
               Info  := 0;
          END;
     END;
END;

PROCEDURE RestoreTypeShield (I, J : Integer);
BEGIN
     CASE J OF
          1 : BEGIN
              Menu [3]^. Lines [I]. Param := ARGON_SCHUTZGAS;
              CurrentDatHandler^. RecordersFields. GasArgon := 100;
              CurrentDatHandler^. RecordersFields. GasHelium := 0;
              END;
          2 : BEGIN
              Menu [3]^. Lines [I]. Param := HELIJ_SCHUTZGAS;
              CurrentDatHandler^. RecordersFields. GasArgon := 0;
              CurrentDatHandler^. RecordersFields. GasHelium := 100;
              END;
          3 : BEGIN
              Menu [3]^. Lines [I]. Param := SMES_SCHUTZGAS;
              CurrentDatHandler^. RecordersFields. GasArgon := 45;
              CurrentDatHandler^. RecordersFields. GasHelium := 55;
              END;
     END;
END;

PROCEDURE InitNewNameBasis (I : Byte; F : Byte);
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 1;
          Y1           := 3;
          TS80         := ' ' + Menu [I-1]^. Lines [F]. Name + ' ';
          FrameSort    := 2;
          WT           := WW [I];
          Realize      := 2;
          Aktive       := False;
          DexParMax    := 60;
          KeysForPress := KeyIfPresent;
          ShadePresent := ShadeIfPresent;
          FNameSCR     := 'Menu4.scr';
          WITH Lines [1] DO BEGIN
               Name  := Dateinahme;
               Num   := 1;
               Info  := 1;
               Param := VerifyDatenBasisName;
               IF Param = '' THEN Param := 'EXAMPLE';
          END;
          WITH Lines [2] DO BEGIN
               Name  := Eingabedaten;
               Num   := 1;
               Info  := 1;
               IF Lines [1]. Param = 'EXAMPLE' THEN
                  Param := '' ELSE
                  Param := HeaderDaten^. FileComment;
          END;
     END;
END;

FUNCTION NotEnterNewNameDatenBasis : Boolean;
BEGIN
     InitNewNameBasis (3, 1);
     IF Pos ('.', Menu [3]^. Lines [1]. Param) <> 0 THEN
        Delete (Menu [3]^. Lines [1]. Param,
                Pos ('.', Menu [3]^. Lines [1]. Param),
                60);
     IF Length (Menu [3]^. Lines [1]. Param) > 8 THEN
        Byte (Menu [3]^. Lines [1]. Param [0]) := 8;
     WinRes [3] := VMenu (Menu [3]^, InMenuStart, OutMenuNoClose, OutMenuNoErase);
     WHILE WinRes [3] > 0 DO BEGIN
           Menu [3]^. Lines [WinRes [3]]. Param :=
    LineEdit (Menu [3]^. X2 - Menu [3]^. DexParMax,
              Menu [3]^. Y1 + Menu [3]^. Lines [WinRes [3]]. y,
              Menu [3]^. DexParMax-1, Menu [3]^. Lines [WinRes [3]]. Param, WindowHHKey);
           IF Pos ('.', Menu [3]^. Lines [1]. Param) <> 0 THEN
              Delete (Menu [3]^. Lines [1]. Param,
                      Pos ('.', Menu [3]^. Lines [1]. Param),
                      60);
           IF Length (Menu [3]^. Lines [1]. Param) > 8 THEN
              Byte (Menu [3]^. Lines [1]. Param [0]) := 8;
           WinRes [3] := VMenu (Menu [3]^, InMenuContinue, OutMenuNoClose, OutMenuNoErase);
     END;
     IF Menu [3]^. Lines [1]. Param = '' THEN
        NotEnterNewNameDatenBasis := False
     ELSE BEGIN
          VerifyDatenBasisName := Menu [3]^. Lines [1]. Param + '.VDB';
          IF FileExist (Menu [3]^. Lines [1]. Param) THEN
             NotEnterNewNameDatenBasis := True
          ELSE BEGIN
             NotEnterNewNameDatenBasis := False;
             InitDatenBasisID;
             HeaderDaten^. FileComment := Menu [3]^. Lines [2]. Param;
             InsertNewFirstRecord;
          END;
     END;
     DoneMenu (3);
END;

FUNCTION InitSearchDatenBasis (I : Byte) : Boolean;
VAR
   SR : SearchRec;
BEGIN
     New (Menu [I]);
     WITH Menu [I]^ DO BEGIN
          X1           := 1;
          Y1           := 2;
          TS80         := ' ' + Menu [2]^. Lines [2]. Name + ' ';
          FrameSort    := 2;
          WT           := WW [I];
          Aktive       := False;
          DexParMax    := 0;
          KeysForPress := KeyNoPresent;
          ShadePresent := ShadeNoPresent;
          FNameSCR     := 'Menu3.scr';
          Realize := 0;
          FindFirst (PATH_FILE + '*.VDB', Archive, SR);
          WHILE DOSError = 0 DO BEGIN
                INC (Realize);
                WITH Lines [Realize] DO BEGIN
                     Name  := SR.Name;
                     Num   := 1;
                     Info  := 0;
                END;
                IF Realize = 21 THEN Break;
                FindNext (SR);
          END;
          IF Realize < 21 THEN
             ShadePresent := ShadeIfPresent;
          IF Realize = 0 THEN InitSearchDatenBasis := False
          ELSE InitSearchDatenBasis := True;
     END;
END;

PROCEDURE DoneSearchBasis (I : Byte);
BEGIN
     IF I < 1 THEN Exit;
     VerifyDatenBasisName := Menu [3]^. Lines [I]. Name;
     LoadDatenBasisID (VerifyDatenBasisName);
END;

PROCEDURE DoneNewNameDatenBasis;
BEGIN
     IF Pos ('.', Menu [3]^. Lines [1]. Param) <> 0 THEN
        Delete (Menu [3]^. Lines [1]. Param,
                Pos ('.', Menu [3]^. Lines [1]. Param),
                60);
     IF Length (Menu [3]^. Lines [1]. Param) > 8 THEN
        Byte (Menu [3]^. Lines [1]. Param [0]) := 8;
     WinRes [3] := VMenu (Menu [3]^, InMenuStart, OutMenuNoClose, OutMenuNoErase);
     WHILE WinRes [3] > 0 DO BEGIN
           Menu [3]^. Lines [WinRes [3]]. Param :=
    LineEdit (Menu [3]^. X2 - Menu [3]^. DexParMax,
              Menu [3]^. Y1 + Menu [3]^. Lines [WinRes [3]]. y,
              Menu [3]^. DexParMax-1, Menu [3]^. Lines [WinRes [3]]. Param, WindowHHKey);
           IF Pos ('.', Menu [3]^. Lines [1]. Param) <> 0 THEN
              Delete (Menu [3]^. Lines [1]. Param,
                      Pos ('.', Menu [3]^. Lines [1]. Param),
                      60);
           IF Length (Menu [3]^. Lines [1]. Param) > 8 THEN
              Byte (Menu [3]^. Lines [1]. Param [0]) := 8;
           WinRes [3] := VMenu (Menu [3]^, InMenuContinue, OutMenuNoClose, OutMenuNoErase);
     END;
     IF Menu [3]^. Lines [1]. Param = '' THEN Exit
     ELSE BEGIN
          VerifyDatenBasisName := Menu [3]^. Lines [1]. Param + '.VDB';
          SaveDatenBasisID (VerifyDatenBasisName);
          HeaderDaten^. FileComment := Menu [3]^. Lines [2]. Param;
     END;
END;

END.
